#!/usr/bin/perl

use strict;
use warnings;

require './hutool.pl';
require './lib.pl';

my @GET_NAME =('mode','name','type');
my @POST_NAME=('mode','grade','subject','type','name','text');

our %GET =&hutool::DECODE_GET(@GET_NAME);
our %POST=&hutool::DECODE_POST(@POST_NAME);

our $log_dir='./log/past';
our $this   = &hutool::THIS();

our $file=sprintf('./log/now.txt');
our $mode_file=sprintf('./log/mode.txt');
our $list_file=sprintf('./log/list.txt');
our $renew_file=sprintf('./log/renew.txt');
our $name_file=sprintf('./log/namelist.txt');


print "Content-type: text/html\n\n";
print &main();

sub main
{
  my $html='';
  my $mode='d';
  my $type='Q';

  $html.=&header();

  if($POST{'mode'} ne ''){$mode=$POST{'mode'};}
  elsif($GET{'mode'} ne ''){$mode=$GET{'mode'};}
  if($POST{'type'} ne ''){$type=$POST{'type'};}
  elsif($GET{'type'} ne ''){$type=$GET{'type'};}

  if(&log_write($file)){}else{}

  $html.=&form($mode,$POST{'grade'},$POST{'subject'},$type,$POST{'name'},$POST{'text'});

  $html.=&footer();

  return $html;
}

sub log_write
{
  my($file)=@_;
  my $resalt=0;

  if(  ($POST{'text'} ne ''  &&
        ($POST{'subject'} eq 'h' || $POST{'subject'} eq 'G' || #提出者か議長の発言
         ($POST{'type'} ne '' && $POST{'grade'} ne '' && $POST{'subject'} ne '' && $POST{'name'} ne '' )
        )
       )
     || 
      (
       $POST{'grade'} ne '' && $POST{'subject'} ne '' &&
       ($POST{'text'} eq 'A' || $POST{'text'} eq 'R' || $POST{'text'} eq 'D')
      )
    )
  {$resalt=1;

    $POST{'text'}=~s/\r//g;
    $POST{'text'}=~s/\n{1,}/<br \/>/g;

    my @list=&hutool::OPEN_FILE($file);
    
    if($POST{'subject'} eq 'h')
    {
      $POST{'name'}='提出者';
      $POST{'subject'}='';
      $POST{'grade'}='';
      $POST{'type'}='';
    }elsif($POST{'subject'} eq 'G')
    {
      $POST{'name'}='議長';
      $POST{'subject'}='';
      $POST{'grade'}='';
      $POST{'type'}='';
    }

    my $newdata=join("\t",time(),$POST{'type'});
    if($POST{'type'} eq 'G')
    {#議案名
      $newdata='';#join("\t",$newdata,$POST{'text'});
      my @l=&lib::get_list($list_file);
      my $wm='G';
      my $num=-1;
      if($l[$POST{'text'}]{'type'} eq 'S' || $l[$POST{'text'}]{'type'} eq 'E'){$wm=$l[$POST{'text'}]{'type'};}

      my %GM=&lib::get_mode($mode_file);
      my %lst;

      foreach(@l)
      {
        %lst=%$_;
        if($lst{'bill'} eq $GM{'bill'})
        {
          $num=$lst{'number'};
          last;
        }
      }

      my $log_f=&lib::logfile_name($log_dir,$num);

      &lib::out_mode($mode_file,$wm,$l[$POST{'text'}]{'bill'},$l[$POST{'text'}]{'name'},
                     $l[$POST{'text'}]{'grade'}.$l[$POST{'text'}]{'subject'},$l[$POST{'text'}]{'type'});

      if(open(LOG,">$log_f"))
      {
        print LOG reverse(@list);
        close(LOG);
        @list=();
      }

    }elsif($POST{'type'} eq 'W')
    {#撤回動議
    }elsif($POST{'type'} eq 'V')# || $POST{'type'} eq 'A' || $POST{'type'} eq 'R' || $POST{'type'} eq 'D'
    {#その他採決系のある動議など
      $POST{'grade'  }=&lib::wide2half($POST{'grade'});
      $POST{'subject'}=&lib::wide2half($POST{'subject'});
      $POST{'name'   }=&lib::wide2half($POST{'name'});
      $newdata=join("\t",$newdata,$POST{'text'},$POST{'grade'},$POST{'subject'},$POST{'name'});
    }else
    {
      $newdata=join("\t",$newdata,$POST{'grade'},$POST{'subject'},$POST{'name'},$POST{'text'});
    }

    if($newdata ne '')
    {
      unshift(@list,"$newdata\n");
    }

    if(-f $file && open(LOG,">$file"))
    {
      print LOG @list;
      close(LOG);
    }

  }else{
$resalt=0;
  }

  if($resalt==1){
    &write_namelist($name_file,$POST{'grade'},$POST{'subject'},$POST{'name'});
    $POST{'grade'}=$POST{'subject'}=$POST{'type'}=$POST{'name'}=$POST{'text'}='';
  }

  return $resalt;
}

sub form
{
  my ($mode,$GRADE,$SUBJECT,$TYPE,$NAME,$TEXT)=@_;
  my $html='';
  my $n;
  my $s;
  my @tmp;

  $html.=sprintf('
 <div class="block" style="position:absolute;left:0px;">
  <div class="name"><span id="ptype"></span> <span id="pgrade"></span><span id="psubject"></span><br /><span id="pname"></span></div>
  <div class="text"><span id="ptext"></span></div>
 </div>');


  my @ns=('n','n','n');
  if($TYPE eq 'Q'){$ns[0]='s';}
  elsif($TYPE eq 'A'){$ns[1]='s';}
  elsif($TYPE eq 'S' || $TYPE eq 'O'){$ns[2]='s';}
  $html.=sprintf('<div style="position:absolute;left:165px;">
<ul class="tab">
<li class="%sl"></li>
<li class="%stitle"><a href="./%s?type=Q">質問</a></li>
<li class="%sr"></li>
<li class="%sl"></li>
<li class="%stitle"><a href="./%s?type=A">回答</a></li>
<li class="%sr"></li>
<li class="%sl"></li>
<li class="%stitle"><a href="./%s?type=S">意見・その他</a></li>
<li class="%sr"></li>
</ul>'
  ,$ns[0],$ns[0],$this,$ns[0]
  ,$ns[1],$ns[1],$this,$ns[1]
  ,$ns[2],$ns[2],$this,$ns[2]);
#まずは、今何をしているかで、入力方法が変わります。<br />
#<a href="%s?mode=d">審議中</a>(発言を入力)／
#<a href="%s?mode=v">動議・採決</a>(採決などの入力)／
#'
#  ,'./writer.cgi'
#  ,'./writer.cgi'
#  ,'./writer.cgi');


  $html.=sprintf('<br style="clear:left;" />
<p><b>説明！！</b><br />
このページは、普段の発言を入力するためのページです。<br />
個人情報は、学年、学科の場合は選択し、名前はカタカナで打ち込みます。スペースを打つ代わりに[F7]を押すと、カタカナになります。<br />
発言情報は、何の発言かは選択で、その内容は書き込み形式となっています。<br />
発言は大体の概要程度に抑え、あまり長文にしないでください。(黒板の再現。別途指示がある場合はそちらを優先。)</p>
');
#  $html.=&print_namelist($name_file);
  $html.=sprintf('<form action="%s" method="POST" name="input">%s','./writer.cgi',"\n");
  $html.=sprintf('<input name="mode" type="hidden" value="%s" id="mode" />%s',$mode,"\n");


#GRADE PART
  $html.=sprintf('学年:%s',"\n");
  if($GRADE eq ''){$GRADE=0;}
  for($n=1;$n<=4;++$n)
  {
    if($n==$GRADE){$s=' checked="checked"'}else{$s='';}
    if($n==1){$s.=' name="f"';}
    push(@tmp,sprintf('<span id="box"><input name="grade" id="grade" type="radio" value="%s" onclick="print_rg(%d);"%s />%s</span>',$n,$n,$s,$n));
  }
  $html.=join(",\n",@tmp);

  $html.="<br />\n";

#SUBJECT PART
  $html.=sprintf('学科:%s',"\n");
#要らない配列。後でセッティングから読み込むように
my @SUBJECTS=('C','J','E','M','F','T','H');
  foreach(@SUBJECTS)
  {
    if($SUBJECT eq $_){$s=' checked="checked"';}else{$s='';}
    $_=sprintf('<span id="box"><input name="subject" id="subject" type="radio" value="%s" onclick="print_rs(\'%s\');"%s />%s</span>',$_,$_,$s,$_);
  }

  $html.=join(",\n",@SUBJECTS);
  if($SUBJECT eq 'h'){$s=' checked="checked"';}else{$s='';}
  $html.=sprintf(',%s<span id="box"><input name="subject" id="subject" type="radio" value="%s" onclick="print_rs(\'h\');"%s />%s</span>',"\n",'h',$s,'提出者');
  if($SUBJECT eq 'G'){$s=' checked="checked"';}else{$s='';}
  $html.=sprintf(',%s<span id="box"><input name="subject" id="subject" type="radio" value="%s" onclick="print_rs(\'G\');"%s />%s</span>',"\n",'G',$s,'議長');

  $html.="<br />\n";

#NAME PART
  $html.=sprintf('名前:<input name="name" type="text" id="name" size="20" value="%s" /><br />%s',$NAME,"\n");


#TYPE PART
#  $html.=sprintf('発言:%s',"\n");
#  @tmp=('質問','回答','意見','その他',
#        'Q','A','S','O');
#  for($n=0;$n<=3;++$n)
#  {
#    if($TYPE eq $tmp[$n+4]){$s=' checked="checked"';}else{$s='';}
#    $tmp[$n]=sprintf('<span id="box"><input name="type" type="radio" value="%s"%s onclick="print_rt(\'%s\');" />%s</span>',$tmp[$n+4],$s,$tmp[$n],$tmp[$n]);
#  }
#  $html.=join(",\n",@tmp[0..3]);
#  %tmp=('Q'->'質問','A'->'回答','S'->'意見','O'->'その他');

  $html.=sprintf('<input name="type" type="hidden" value="%s" />',$TYPE);
#  $html.="<br />\n";


#TEXT PART
  $html.=sprintf('文章:<textarea name="text" id="text" cols="43" rows="4">%s</textarea><br />あまり長文は書かないでください。<br />%s',$TEXT,"\n");

#SUBMIT BUTTOM
  $html.=sprintf('<input type="button" value="書き込み" onclick="last_change();">%s',"\n");


  $html.=sprintf('</form>%s</div>%s',"\n","\n");


  return $html;
}

sub list
{
 my($file)=@_;
  my $html='';
  my @list=&hutool::OPEN_FILE($file);

  foreach(@list)
  {
    $_=sprintf('<div style="border:1px solid black;">%s</div>',$_);
  }

  $html=join('',@list);

  return $html;
}

sub print_namelist
{
  my($file)=@_;
  my $html='';
  my @list=&hutool::OPEN_FILE($file);

  $html.=sprintf('<select>');

  foreach(@list)
  {
    my(%data)=&read_namelist($_);
    $html.=sprintf('<option onclick="input_personal(%d,%s,%s)">%d%s:%s</option>'
           ,$data{'grade'},$data{'subject'},$data{'name'}
           ,$data{'grade'},$data{'subject'},$data{'name'});
  }

  $html.=sprintf('</select>');

  return $html;
}

sub read_namelist
{
  my %ret;
  ($ret{'no'},$ret{'grade'},$ret{'subject'},$ret{'name'})=split(/\t|\n/,$_[0]);
  return %ret;
}

sub write_namelist
{
  my($file,$grade,$subject,$name)=@_;

  if($grade =~/[1-4]/ && $subject ne 'none' && $name ne '')
  {
    my @list=&hutool::OPEN_FILE($file);
    my $newdata=join("\t",1,$grade,$subject,$name);

    foreach(@list)
    {
      if($_ =~/[\w\t]/)
      {
        my(%data)=&read_namelist($_);
        if($data{'grade'} eq $grade && $data{'subject'} eq $subject && $data{'name'} eq $name)
        {
          ++$data{'no'};
          $_=join("\t",$data{'no'},$data{'grade'},$data{'subject'},$data{'name'})."\n";

          $newdata='';
          last;
        }
      }
    }

    if($newdata ne '')
    {
      push(@list,"$newdata\n");
    }

    @list=&heapsort(@list);

open(F,">$file");
print F @list;
close(F);
      return 1;

  }
  return 0;
}

sub heapsort
{
  my(@list)=@_;
  my $i;
  my $n=scalar(@list);
  for($i=int($n/2);1<=$i;--$i){@list=&pushdown($i,$n,@list);}
  for($i=$n;2<=$i;--$i)
  {
    ($list[0],$list[$i-1])=($list[$i-1],$list[0]);
    @list=&pushdown(1,$i-1,@list);
  }
  return @list;
}

sub pushdown
{
  my ($first,$last,@list)=@_;
  my $r=$first;
  my $k=$r*2;

  while($k<=$last)
  {
    if($k<$last && 0<&compare($list[$k],$list[$k-1])){++$k;}
    if(0<=&compare($list[$r-1],$list[$k-1])){last;}
    ($list[$r-1],$list[$k-1])=($list[$k-1],$list[$r-1]);
    $r=$k;
    $k=$r*2;
  }
  return @list;
}


sub compare
{
  my($n1,$g1,$s1,$nm1)=split(/\t/,$_[0]);
  my($n2,$g2,$s2,$nm2)=split(/\t/,$_[1]);

  if($n1<$n2){return 1;}
  if($n1>$n2){return -1;}

  if($g1<$g2){return 1;}
  if($g1>$g2){return -1;}

  my (%subject)=('C'=>0,'J'=>1,'E'=>2,'F'=>3,'M'=>4,'T'=>5,'H'=>6);

  if($subject{$s1}>$subject{$s2}){return 1;}
  if($subject{$s1}<$subject{$s2}){return -1;}

  if($nm1 gt $nm2){return 1;}
  if($nm1 lt $nm2){return -1;}

  return 0;
}

sub login{
  my ($name)=@_;
  my $html='';
  my $file=join('.',&lib::make_filename(),'txt');
#  my @list=&hutool::OPEN_FILE(&hutool::PASS_JOIN('/',$log_dir,&hutool::ENCODE($name),$file));
  my @list=&hutool::GET_FILE_LIST('directory',$log_dir);

  $html.=sprintf('<form action="%s" method="POST">
'
  ,'./writer.cgi');

  foreach(@list){}

  $html.=sprintf('</form>');

  return $html;
}

sub header
{
  return sprintf('<html>
<head>
 <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
 <title>入力用</title>
 <style>
  <!--
  -->
 </style>
 <script type="text/javascript" src="./change_words.js"></script>
 <script laguage="JavaScript">
<!--

  function renew()
  {
    document.input.name.value=hira2kata(document.input.name.value);
    print_ta();
  }
  function print_ta(){
    document.input.name.value                     = hira2kata(document.input.name.value);
    //document.getElementById("text").innerHTML     = wide2half(document.getElementById("text").innerHTML);
    if(document.getElementById("pname").innerHTML != "議長" &&
       document.getElementById("pname").innerHTML != "提出者")
    {
      document.getElementById("pname").innerHTML    = document.input.name.value;
    }
    document.getElementById("ptext").innerHTML    = document.getElementById("text").innerHTML;
  }
  function print_rg(g){
    if(document.getElementById("pname").innerHTML != "議長" &&
       document.getElementById("pname").innerHTML != "提出者")
    {
      document.getElementById("pgrade").innerHTML   = g;
    }
  }
  function print_rs(s){
    if(s == "h")
    {
      print_rg("");
      document.getElementById("psubject").innerHTML="";
      //print_rs("");
      document.getElementById("pname").innerHTML  = "提出者";
    }else if(s == "G")
    {
      print_rg("");
      document.getElementById("psubject").innerHTML="";
      //print_rs("");
      document.getElementById("pname").innerHTML  = "議長";
    }else
    {
      document.getElementById("psubject").innerHTML = s;
    }
  }
  function print_rt(t){
    if(document.getElementById("pname").innerHTML != "議長" &&
       document.getElementById("pname").innerHTML != "提出者")
    {
      document.getElementById("ptype").innerHTML = t;
    }
  }

  function input_personal(g,s,n)
  {
    document.getElementById("pgrade").innerHTML   = g;
    document.getElementById("psubject").innerHTML = s;
    document.getElementById("pname").innerHTML    = n;
  }

  function last_change()
  {
    document.input.name.value=hira2kata(document.input.name.value);
    document.input.submit();
  }

-->
  </script>
 <link rel="icon" href="./favicon.ico" type="image/vnd.microsoft.icon" />
 <link rel="stylesheet" href="./material/style.css" type="text/css" />
</head>
<body style="overflow-x:scroll;" onLoad="document.forms[0].elements[1].focus();setInterval(\'renew()\',2000)">
');
}
# style="overflow-y:hidden;"
sub footer
{
  return sprintf('</body>%s</html>%s',"\n","\n");
}
